# This is a basic workflow to help you get started with Actions

name: Deployment pipeline

# Controls when the workflow will run
on:
  # Triggers the workflow on push or pull request events but only for the master branch
  push:
    branches: [ master ]
  pull_request:
    branches: [ master ]
    types: [opened, synchronize]

  # Allows you to run this workflow manually from the Actions tab
  workflow_dispatch:

# A workflow run is made up of one or more jobs that can run sequentially or in parallel
jobs:
  # This workflow contains a single job called "build"
  build:
    # The type of runner that the job will run on
    runs-on: ubuntu-18.04

    # Steps represent a sequence of tasks that will be executed as part of the job
    steps:
      # Checks-out your repository under $GITHUB_WORKSPACE, so your job can access it
      - uses: actions/checkout@v2

      # Setup node.js
      - uses: actions/setup-node@v1
        with: 
          node-version: '12.x'
      - name: npm install
        run: npm install        
      - name: lint
        run: npm run eslint
      - name: test
        run: npm test

      - name: build
        run: npm run build

      # run cypress tests ex 11.9
      - name: e2e tests
        uses: cypress-io/github-action@v2
        with: 
          command: npm run test:e2e
          start: npm run start-prod
          wait-on: http://localhost:5000
      
      # deploy to heroku
      - name: deploy to heroku
        uses: akhileshns/heroku-deploy@v3.12.12 # This is the action
        if:  ${{github.event_name == 'push' && !contains(join(github.event.commits.*.message,' '), '#skip')}}
        with:
          heroku_api_key: ${{secrets.HEROKU_API_KEY}}
          heroku_app_name: "fso-pokedex-cm" #Must be unique in Heroku
          heroku_email: "webmaster@cherylli.com"
          healthcheck: "https://fso-pokedex-cm.herokuapp.com/health"
          checkstring: "ok"
          rollbackonhealthcheckfailed: true
      
      # versioning
      - uses: actions/checkout@v2

      - name: Bump version and push tag
        if: ${{github.event_name == 'push' && !contains(join(github.event.commits.*.message,' '), '#skip')}}
        uses: anothrNick/github-tag-action@eca2b69f9e2c24be7decccd0f15fdb1ea5906598
        env:
          GITHUB_TOKEN: ${{ secrets.GITHUB_TOKEN }}

    #Note: New in Feb 2021
    # If any commit message in your push or the HEAD commit of your PR contains the strings 
    # [skip ci], [ci skip], [no ci], [skip actions], or [actions skip] workflows triggered
    # on the push or pull_request events will be skipped.

    # Slack notification - webhook
      - uses: 8398a7/action-slack@v3
      with:
        status: ${{ job.status }}
        fields: repo,message,commit,author,action,eventName,ref,workflow,job,took,pullRequest # selectable (default: repo,message)
      env:
        SLACK_WEBHOOK_URL: ${{ secrets.SLACK_WEBHOOK_URL }} # required
      if: always() # Pick up events even if the job fails or is canceled.

